diff a/hat/hatlessrun b/hat/hatlessrun
--- /dev/null
+++ b/hat/hatlessrun
@@ -0,0 +1,60 @@
+/* vim: set ft=java:
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+import static bldr.Bldr.*;
+
+
+void main(String[] args) {
+  var name = args[0];
+  var argn=1;
+  var hatDir = Dir.current();
+  var buildDir = hatDir.existingBuildDir("build");
+  var hatlessExampleDir = hatDir.dir("hatless-examples/"+name);
+  var source =hatlessExampleDir.sourceDir("src/main/java");
+  var resources =hatlessExampleDir.sourceDir("src/main/resources");
+  var opencl = buildDir.jarFile("jextracted-opencl.jar");
+  var opengl = buildDir.jarFile("jextracted-opengl.jar");
+
+  var example = buildDir.jarFile("hatless-example"+name+".jar");
+
+  java($->$
+    .enable_preview()
+    .start_on_first_thread()
+    .enable_native_access("ALL-UNNAMED")
+    .class_path(opencl, opengl, example.create($$->$$
+        .javac($$$->$$$
+            .enable_preview()
+            .source(24)
+            .class_path(opencl, opengl)
+            .source_path(source)
+        )
+        .dir_list(resources)
+      )
+    )
+    .main_class(name+".Main")
+    .args(Arrays.copyOfRange(args, argn, args.length))
+  );
+
+}
